resources:
  # Optional; if left out, automatically pick the cheapest cloud.
  cloud: aws
  use_spot: true
  image_id:
      us-west-2: ami-0604d81f2fd264c7b
  instance_type: g4dn.xlarge
workdir: .

# Typical use: pip install -r requirements.txt
# Invoked under the workdir (i.e., can use its files).
setup: |
  echo "Running setup."
  export TASK_NAME=prism
  sudo yum install rsync -y
  sudo yum install gcc -y
  sudo dnf install -y kernel-devel-$(uname -r) kernel-headers-$(uname -r) kernel-modules-extra-$(uname -r)
  sudo dnf config-manager -y  --add-repo https://developer.download.nvidia.com/compute/cuda/repos/amzn2023/x86_64/cuda-amzn2023.repo
  sudo dnf module install -y nvidia-driver:latest-dkms
  sudo mkfs -t xfs /dev/nvme1n1
  mkdir -p /home/ubuntu/$TASK_NAME
  sudo mount /dev/nvme1n1 /home/ubuntu/$TASK_NAME
  sudo chown ubuntu:ubuntu /home/ubuntu/$TASK_NAME
  mv /home/ubuntu/miniconda3 /home/ubuntu/$TASK_NAME/miniconda3
  ln -s /home/ubuntu/$TASK_NAME/miniconda3 /home/ubuntu/miniconda3
  conda create -p /home/ubuntu/$TASK_NAME/envs/$TASK_NAME -y  python=3.8
  conda activate /home/ubuntu/$TASK_NAME/envs/$TASK_NAME
  conda install pytorch torchvision torchaudio pytorch-cuda=12.1 -c pytorch -c nvidia -y
  conda install matplotlib -y
  pip cache purge
  pip install pytorch-msssim compressai nvidia-dali-cuda120 --no-cache-dir
  pip cache purge

  which aws
  aws --version
  if [ -f "${reads}.h5" ]; then
      echo "${reads}.h5 exists"
  else
      start1=`date +%s`
      aws s3 cp s3://nextflow-bucket-s3/data/${reads}.h5 .
      end=`date +%s`
      runtime=\$((end-start1))
      FILESIZE=\$(stat -c%s "${reads}.h5")
      flock -x 1
      echo "\$FILESIZE \$runtime" >> $CHESS_WORKFLOW_HOME/downloadS3HPC.txt
      flock -u 1
  fi
  pip install py4DSTEM==0.13.8
  pip install numpy==1.23.5
  pip install matplotlib
  pip install yaml
  if [ -f "example.py" ]; then
      rm example.py
  fi

# Typical use: make use of resources, such as running training.
# Invoked under the workdir (i.e., can use its files).
run: |
  echo "Hello, PRISM!"
  export TASK_NAME=prism
  conda activate /home/ubuntu/$TASK_NAME/envs/$TASK_NAME

  mkdir ${start}
  ls
  python example.py
  echo "----------------------------"
  ls ${start}
  start1=`date +%s%N`
  aws s3 cp ${start}/ s3://nextflow-bucket-s3/${start}/ --recursive
  end=`date +%s%N`
  runtime=\$((end-start1))
  FILESIZE=\$(du -sh --apparent-size ${start} | awk '{ print \$1 }')
  flock -x 1
  echo "\$FILESIZE \$runtime" >> $CHESS_WORKFLOW_HOME/downloadHPCS3.txt
  flock -u 1
  export done=\$(( \$done + 1 ))
